﻿(defun c:xd (/ xd-box tmp file dcl_id ent dlst)
 (defun xd-box	(dlst)
   (setq tmp  (vl-filename-mktemp "Tmp.dcl")
  file (open tmp "w")
   )
   (write-line
     "XdBox:dialog{label=\"Données étendues\";"
     file
   )
   (foreach l dlst
     (write-line
(strcat	":boxed_row{label="
	(vl-prin1-to-string (car l))
	";:column{"
)
file
     )
     (foreach p (cdr l)
(write-line
  (strcat ":text{label=\""
	  (cond
	    ((= 1000 (car p)) "1000  Chaîne : ")
	    ((= 1002 (car p)) "1002  Accolade : ")
	    ((= 1003 (car p)) "1003  Calque : ")
	    ((= 1004 (car p)) "1004  Binaire : ")
	    ((= 1005 (car p)) "1005  Maintient : ")
	    ((= 1010 (car p)) "1010  Point : ")
	    ((= 1011 (car p)) "1011  Position : ")
	    ((= 1012 (car p)) "1012  Déplacement : ")
	    ((= 1013 (car p)) "1013  Direction : ")
	    ((= 1040 (car p)) "1040  Réel : ")
	    ((= 1041 (car p)) "1041  Distance : ")
	    ((= 1042 (car p)) "1042  Echelle : ")
	    ((= 1070 (car p)) "1070  Entier court : ")
	    ((= 1071 (car p)) "1071  Entier long : ")
	  )
	  "\";}"
  )
  file
)
     )
     (write-line "}:column{" file)
     (foreach p (cdr l)
(write-line
  (strcat ":text{label=\""
	  (vl-princ-to-string (cdr p))
	  "\";}"
  )
  file
)
     )
     (write-line "}}" file)
   )
   (write-line "spacer;ok_only;}" file)
   (close file)
   (setq dcl_id (load_dialog tmp))
   (if	(not (new_dialog "XdBox" dcl_id))
     (exit)
   )
   (start_dialog)
   (unload_dialog dcl_id)
   (vl-file-delete tmp)
 )

 (if
   (and
     (setq ent (car (entsel)))
     (setq dlst (cdr (assoc -3 (entget ent '("*")))))
   )
    (xd-box dlst)
    (alert "Cet objet ne comporte pas de données étendues")
 )
 (princ)
) 